// CBall.cpp

#include "CBall.h"

/*
 *====================================================================
 *					Overloaded CBall Constructor
 *
 * desc: CBall constructor that sets the ball's initial position
 * @param: Two scalar values that are used to set m_Position
 *====================================================================
 */
CBall::CBall(scalar xPos, scalar yPos)
{
	m_Position.vector_2d[0] = xPos;
	m_Position.vector_2d[1] = yPos;
}

/*
 *====================================================================
 *					Overloaded CBall Constructor
 *
 * desc: CBall constructor that sets the ball's initial position and
 *       it's velocity
 * @param: Four scalar values. The first two are used to set the
 *         values in m_Position, and the second two to set the values
 *         in m_Velocity
 *====================================================================
 */
CBall::CBall(scalar xPos, scalar yPos, scalar xVel, scalar yVel)
{
	// Set the position
	m_Position.vector_2d[0] = xPos;
	m_Position.vector_2d[1] = yPos;

	// Set the velocity
	m_Velocity.vector_2d[0] = xVel;
	m_Velocity.vector_2d[1] = yVel;
}

/*
 *====================================================================
 *					InitBall()
 *
 * desc: Loads the ball bitmap that will be used in the game
 *====================================================================
 */
void CBall::InitBall()
{
	m_BallSurface = SDL_LoadBMP("images/ball.bmp");
}

/*
 *====================================================================
 *					DrawBall()
 *
 * desc: Draw's the ball onto the screen. The x,y coordinates are
 *			 taken from the CVector in the CBall class
 * @param: Takes an SDL_Surface named paddle that will be blitted onto
 *			   the screen
 *====================================================================
 */
void CBall::DrawBall(SDL_Surface *ball, SDL_Surface *gameScreen)
{
  SDL_Rect dest;
	dest.x = static_cast<int>(m_Position.vector_2d[0]);
	dest.y = static_cast<int>(m_Position.vector_2d[1]);
  SDL_BlitSurface(ball, NULL, gameScreen, &dest);
}