// CBall.h
#ifndef CBALL_H
#define CBALL_H

#include <sdl.h>
#include "CVector.h"

class CBall
{
public:
	CBall();	// Constructor

	// Overloaded constructor to set the Position
	CBall(scalar xPos, scalar yPos);

	// Overloaded constructor to set the Position and Velocity
	CBall(scalar xPos, scalar yPos, scalar xVel, scalar yVel);

	void InitBall();	// Initialize the ball
	void DrawBall(SDL_Surface* ball, SDL_Surface* gameScreen);	// Load the ball onto the screen

	SDL_Surface * m_BallSurface;

	CVector m_Position;		// The Ball's (x,y) coordinates on the game board
	CVector m_Velocity;		// The Ball's traveling velocity that is updated every frame
};

#endif CBALL_H