// CGame.h
#ifndef CGAME_H
#define CGAME_H

#include <sdl.h>
#include <stdlib.h>
#include <stdio.h>
#include "CBall.h"
#include "CPaddle.h"
#include "CVector.h"
#include "Font.h"

class CGame
{
public:
	CGame(){};

	// Draw the background onto the game surface
	void DrawBackground(SDL_Surface * background, SDL_Surface * gameScreen);

	void DrawScene();		// Draw the game into the buffer

	void InitBackground();		// Initialize the background image

	
	void InitGame();    // Initialize the game itself.

	// Initialize the game images
	void InitImages(CBall &ball, CPaddle &player1, CPaddle &player2, CGame &background);

	// Initialize the game fonts
	void InitFonts(Font &text);

	// Draw the game images and everything else
	void DrawScene(CBall &ball, CPaddle &player1, CPaddle &player2, CGame &game);

	void PerformAI();	// Perform the artifical intelligence for the paddle

	void CalculateFPS();	// Calculate the frames per second

	float m_fCurrFPS;		//current FPS counter

	float m_fElapsedTime;		//elapsed time between two frames

	// Surface to store the game's background image
	SDL_Surface * m_BackgroundSurface;

	// The game screen that displays everything
	SDL_Surface * m_GameScreen;

	// Handles key events
	Uint8* m_keys;

	// Game Fonts
	Font Text;
	SDLFont *m_Font1;
	SDLFont *m_Font2;
	SDLFont *m_Font3;

	// Game Scores
	int m_Score[2]; // m_Score[0] == Player 1's score
									// m_Score[1] == Player 2's score

	// Game States
	bool m_GameDone;		// Flag to say whether the game is over with or not
	bool m_GamePause;		// Is the game paused?
};

#endif  CGAME_H