// CPaddle.cpp

#include "CPaddle.h"

/*
 *====================================================================
 *					CPaddle Overloaded constructor
 *
 * desc: Overloaded constructor for CPaddle.
 * @param: Takes two scalar values that are set to CPaddle's x and y 
 *         coordinates. If the paddle is controlled by AI, perform the
 *				 AI as well.
 *====================================================================
 */
CPaddle::CPaddle(scalar xPos, scalar yPos)
{
	m_Position.vector_2d[0] = xPos;
	m_Position.vector_2d[1] = yPos;
}


/*
 *====================================================================
 *					InitPaddle()
 *
 * desc: Loads the paddle bitmap that will be used in the game
 *====================================================================
 */
void CPaddle::InitPaddle()
{
	m_PaddleSurface = SDL_LoadBMP("images/paddle.bmp");
}

/*
 *====================================================================
 *					DrawPaddle()
 *
 * desc: Draw's the paddle onto the screen. The x,y coordinates are
 *			 taken from the CVector in the CPaddle class
 * @param: Takes an SDL_Surface named paddle that will be blitted onto
 *			   the screen
 *====================================================================
 */
void CPaddle::DrawPaddle(SDL_Surface *paddle, SDL_Surface *gameScreen)
{
  SDL_Rect dest;
	dest.x = static_cast<int>(m_Position.vector_2d[0]);
	dest.y = static_cast<int>(m_Position.vector_2d[1]);
  SDL_BlitSurface(paddle, NULL, gameScreen, &dest);
}
