// CPhysics.cpp

#include "CPhysics.h"

/*
 *====================================================================
 *					CheckWall()
 *
 * desc: Check's the ball's position against the game walls. If they
 *       collide, 'bounce' the ball off that wall
 *====================================================================
 */
void CPhysics::CheckWall()
{
	if (g_Ball.m_Position.vector_2d[1] >= 465)
		g_Ball.m_Velocity.vector_2d[1] *= -1;
	if (g_Ball.m_Position.vector_2d[1] <= 0)
		g_Ball.m_Velocity.vector_2d[1] *= -1;
}

/*
 *====================================================================
 *					CheckPaddle1()
 *
 * desc: Check's the ball's position against player 1's paddle (the 
 *       left one)If they collide, 'bounce' the ball off that paddle 
 *			 and increase it's velocity
 *====================================================================
 */
bool CPhysics::CheckPaddle1()
{
	// Paddle left & right attributes
	scalar l_PaddleLeft = g_Player1.m_Position.vector_2d[0];
	scalar l_PaddleRight = g_Player1.m_Position.vector_2d[0] + 20;
	scalar l_PaddleTop = g_Player1.m_Position.vector_2d[1];
	scalar l_PaddleBottom = g_Player1.m_Position.vector_2d[1] + 100;

	// Ball left & right attributes
	scalar l_BallLeft = g_Ball.m_Position.vector_2d[0];
	scalar l_BallRight = g_Ball.m_Position.vector_2d[0] + 8;
	scalar l_BallTop = g_Ball.m_Position.vector_2d[1];
	scalar l_BallBottom = g_Ball.m_Position.vector_2d[1] + 8;

  if (l_PaddleBottom < l_BallTop) return false;
  if (l_PaddleTop > l_BallBottom) return false;

  if (l_PaddleRight < l_BallLeft) return false;
  if (l_PaddleLeft > l_BallRight) return false;

	g_Ball.m_Velocity.vector_2d[0] *= -1;
	g_Ball.m_Velocity.vector_2d[0] *= 1.1;
	g_Ball.m_Velocity.vector_2d[1] *= 1.1;

	return true;
}

/*
 *====================================================================
 *					CheckPaddle2()
 *
 * desc: Check's the ball's position against player 1's paddle (the 
 *       left one)If they collide, 'bounce' the ball off that paddle 
 *			 and increase it's velocity
 *====================================================================
 */
bool CPhysics::CheckPaddle2()
{
	// Paddle left & right attributes
	scalar l_PaddleLeft = g_Player2.m_Position.vector_2d[0];
	scalar l_PaddleRight = g_Player2.m_Position.vector_2d[0] + 20;
	scalar l_PaddleTop = g_Player2.m_Position.vector_2d[1];
	scalar l_PaddleBottom = g_Player2.m_Position.vector_2d[1] + 100;

	// Ball left & right attributes
	scalar l_BallLeft = g_Ball.m_Position.vector_2d[0];
	scalar l_BallRight = g_Ball.m_Position.vector_2d[0] + 8;
	scalar l_BallTop = g_Ball.m_Position.vector_2d[1];
	scalar l_BallBottom = g_Ball.m_Position.vector_2d[1] + 8;

  if (l_PaddleBottom < l_BallTop) return false;
  if (l_PaddleTop > l_BallBottom) return false;

  if (l_PaddleRight < l_BallLeft) return false;
  if (l_PaddleLeft > l_BallRight) return false;

	g_Ball.m_Velocity.vector_2d[0] *= -1;
	g_Ball.m_Velocity.vector_2d[0] *= 1.1;
	g_Ball.m_Velocity.vector_2d[1] *= 1.1;

	return true;
}

/*
 *====================================================================
 *					ClipPaddle()
 *
 * desc: Clip's both paddles so they don't go off the screen
 *====================================================================
 */
void CPhysics::ClipPaddles()
{
	if (g_Player1.m_Position.vector_2d[1] <= 5)
		g_Player1.m_Clipped[0] = true;
	else
		g_Player1.m_Clipped[0] = false;

	if (g_Player1.m_Position.vector_2d[1] >= 375)
		g_Player1.m_Clipped[1] = true;
	else
		g_Player1.m_Clipped[1] = false;

	if (g_Player2.m_Position.vector_2d[1] <= 5)
		g_Player2.m_Clipped[0] = true;
	else
		g_Player2.m_Clipped[0] = false;

	if (g_Player2.m_Position.vector_2d[1] >= 375)
		g_Player2.m_Clipped[1] = true;
	else
		g_Player2.m_Clipped[1] = false;
}