// CVector.h
#ifndef VECTOR_H
#define VECTOR_H

typedef float scalar;

class CVector
{
public:
	CVector(){}

	// Copy Constructor
	CVector(const CVector &Rhs);
	
	// Overloaded constructor, takes two scalar values and assigns them to vector_2d
	CVector(scalar X, scalar Y);

	// Overloaded += operator, adds two vectors
	const CVector& operator +=(const CVector& Rhs);

	// Overloaded -= operator, subtracts two vectors
	const CVector& operator -=(const CVector& Rhs);

	// Overloaded != operator
	inline const bool operator!=(const CVector &Rhs) const;

	// Overloaded == operator
	inline const bool CVector::operator ==(const CVector &Rhs) const;

	// 2D Dot Product
	const CVector& DotProduct(CVector &Lhs, const CVector &Rhs) const;

	// Holds an x and y value for an object
	scalar vector_2d[2];

	// The dot product of a CVector
	scalar dot_product[2];
};

#endif VECTOR_H
