// Font.h

#ifndef FONT_H
#define FONT_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <sdl.h>

struct SDLFont
{
	SDL_Surface *font;		// The SDL surface for the font image
	int width;						// Width of the SDL surface (height)
	int charWidth;				// Width of one block character in the font
	int *widths;					// Real widths of all the fonts
	unsigned char *data;	// The raw font data
};

class Font
{
public:
	void DrawFont(SDL_Surface *screen, SDL_Surface *img, int x,
								int y, int w, int h, int x2, int y2);

	SDLFont *initFont(char *fontdir, float r, float g, float b, float a);

	void drawString(SDL_Surface *screen, SDLFont *font, int x, int y, char *str, ...);

	int stringWidth(SDLFont *font, char *str, ...);

	void freeFont(SDLFont *font);

	inline SDLFont *initFont(char *fontdir, float r, float g, float b)
	{
		return initFont(fontdir, r, g, b, 1);
	}

	inline SDLFont *initFont(char *fontdir)
	{
		return initFont(fontdir, 1, 1, 1, 1);
	}

	SDLFont m_FontStruct;
};

#endif  FONT_H