// main.cpp

#include "Common.h"
#include "AI.h"
#include "Font.h"

extern CPhysics g_Physics;	// Common physics code
AI Computer;			// Artifical Intelligence

int main(int argc, char *argv[])
{
	g_Game.InitGame();
	g_Game.m_GamePause = false;
	g_Game.m_GameScreen = SDL_SetVideoMode(640,480,32,SDL_HWSURFACE|SDL_HWPALETTE|SDL_DOUBLEBUF); // Create a 640x480x32 window

	if ( g_Game.m_GameScreen == NULL )
  {
    printf("Unable to set 640x480 video: %s\n", SDL_GetError());
    exit(1);
	}

  g_Game.InitImages(g_Ball, g_Player1, g_Player2, g_Game);
	g_Game.DrawBackground(g_Game.m_BackgroundSurface, g_Game.m_GameScreen);

	while(g_Game.m_GameDone == false)
  {
    SDL_Event event;

    while ( SDL_PollEvent(&event) )
    {
      if ( event.type == SDL_QUIT )  { g_Game.m_GameDone = true;  }

      if ( event.type == SDL_KEYDOWN )
      {
        if ( event.key.keysym.sym == SDLK_ESCAPE ) { g_Game.m_GameDone = true; }
				if ( event.key.keysym.sym == 'p') 
					g_Game.m_GamePause = !g_Game.m_GamePause;
      }
    }
    g_Game.m_keys = SDL_GetKeyState(NULL);

		g_Game.CalculateFPS();

		char cTitle[255];
		sprintf(cTitle,"Pong: %f", g_Game.m_fCurrFPS);

		SDL_WM_SetCaption(cTitle, "icon.ico");	// Set the window caption

		g_Physics.ClipPaddles();

		Computer.PerformAI();
		
		if (g_Game.m_GamePause == false) 
		{
			g_Ball.m_Position.vector_2d[0] += g_Ball.m_Velocity.vector_2d[0];
			g_Ball.m_Position.vector_2d[1] += g_Ball.m_Velocity.vector_2d[1];

			g_Physics.CheckWall();
		  g_Physics.CheckPaddle1();
			g_Physics.CheckPaddle2();

			///////////// PLAYER 1 CONTROLS ////////////
			if (g_Player1.m_Clipped[0] == false && g_Game.m_keys['w'])	
				g_Player1.m_Position.vector_2d[1] -= 2.5;
			if (g_Player1.m_Clipped[1] == false && g_Game.m_keys['s'])	
				g_Player1.m_Position.vector_2d[1] += 2.5;

			///////////// PLAYER 2 CONTROLS ////////////
			g_Player2.m_Human = false;
			if (g_Player2.m_Clipped[0] == false && g_Player2.m_Human != false 
																					&& g_Game.m_keys[SDLK_UP]) 
				g_Player2.m_Position.vector_2d[1] -= 2.5;
			if (g_Player2.m_Clipped[1] == false && g_Player2.m_Human != false 
																					&& g_Game.m_keys[SDLK_DOWN]) 
				g_Player2.m_Position.vector_2d[1] += 2.5;
			g_Game.DrawScene(g_Ball, g_Player1, g_Player2, g_Game);
		}
  }
  return 0;
}
